#!/usr/bin/python
# -*- coding: utf-8 -*-
import os;
import sys;
import time;
import thread;
import random;
import datetime;
import logging;

from ctypes import *
from string import *
from math   import *

# private module
from CommonV2 import *;

myThreadLock = thread.allocate_lock();  #Allocate a lock

# partiton handle
class BurnPara:
    def __init__(self):
        self.erase = False;
        self.all = False;
        self.list = False;
        self.part = None;
        self.fw = None;
        self.parse_partition_tag=False;
        self.partition_cfg=[[0]*4]*17;
        self.devmode = False;
        self.devmodepara='256'
#===============================================================
#define print 
#===============================================================

def log_init(log_level):
    """
    init the logger
    """
    global logger;
    logger=logging.getLogger('Productionlog');
    #set level NOTSET < DEBUG < INFO < WARNING < ERROR < CRITICAL
    logger.setLevel(log_level)
    #create the handler that write log
    fh = logging.FileHandler('log.txt')
    fh.setLevel(log_level)
    #create the handler that output console
    ch = logging.StreamHandler()
    ch.setLevel(logging.INFO)
    #define output formatter handler
    formatter=logging.Formatter('%(lineno)d - %(levelname)s - %(message)s')
    fh.setFormatter(formatter)
    ch.setFormatter(formatter)
    #add handler to logger
    logger.addHandler(fh)
    logger.addHandler(ch)
    #record a log
    logger.debug('debuglog init')
    return 0


def NT_PRINT(param):
    print(param);

def LINUX_PRINT(param):
    logger.debug(param);

def print_log(param):
    if (os.name == 'nt'):
        NT_PRINT(param);
    elif(os.name == 'posix'):
        LINUX_PRINT(param);

#===============================================================
#  TO WHO MAY NEED TO MAINTAIN THIS FILE
#  http://docs.python.org/2/library/ctypes.html
#  << CORE PYTHON PROGRAMMING>>
#===============================================================

#===============================================================
#windows pc tool burn
def Production(script_dll, product_dll, product_tid, app_type, fw):
    """
    工具调用的入口
    app_type: 指定当前应用程序执行的类型:
        0x01:ADFU量产 / 0x02:ADFU升级 / 0x03:U盘量产 / 0x04:U盘升级 / 0x05:FLASH_DUMP
    """
    try:
        obj = ClassProduction(product_tid, fw);
        obj.InitProduction_NT(script_dll, product_dll);
        if (app_type == 0x01):
            obj.DoADFU();
    except Exception as e:
        print e;
#===============================================================
#use cmdline burn
def Cmd_Production(script_dll, product_dll, fw, Para):
    """
    命令方式量产入口
    burnPara: 命令函数输入参数
    """
    try:
        obj = ClassProduction(0, fw);
        log_init(logging.DEBUG);
        log='fw path:%s'%fw
        print_log(log);
        obj.InitProduction(script_dll, product_dll,Para);
        if Para.list == True :
            obj.ShowPartitions(fw,Para);
        else:
            obj.SetCmdBurnPara(Para);
            obj.DoADFU();
    except Exception as e:
        print e;


#===============================================================
# Redirect the output
class stdout:
    def __init__(self, tid):
        self.tid = tid;
        self.__console__ = sys.stdout

    def write(self, buf):
        if ((len(buf) > 0) & (buf[0] != '\n')):
            if (os.name == 'nt'):
                windll.kernel32.OutputDebugStringA('%s\n' %(buf));
                if (self.tid == 0):
                    self.__console__.write(buf + '\n');


#===============================================================
# production class
class ClassProduction(object):
    def __init__(self, product_tid, dbg_fw):
        """
        initialize the private member variables
        """
        self.debug = False;
        if (0 == product_tid):
            self.debug = True;

        #redirect print
        if (os.name == 'nt'):
            self.sysout = sys.stdout;
            out = stdout(product_tid);
            sys.stdout = out;
        
        self.fwscript   = None;
        self.partitions = 11;
        self.err_code   = 0;
        self.hdcp_burn  = 0;    # hdcp burn flag
        self.ictype     = 0;
        self.boardtypes = 0;
        self.udisk_dir  = '0';
        
        #Alloc memory for global, avoid memory fragments
        self.tool_cfg   = c_buffer('\0', 512);
        self.sn         = c_buffer('\0', 16);
        self.ext_cmd    = (c_byte * 16)();
        self.buffer     = (c_byte * CN_PAKET_SIZE)();
        
        self.product = None;
        self.product_tid = product_tid;
        self.dbg_fw  = dbg_fw;
            
        self.start = datetime.datetime.now();

    def __del__(self):
        """
        destruction
        """
        # Close Firmware
        if (None != self.fwscript):
            self.fwscript.Close();
                
        # release memory
        if (None != self.buffer):
            del self.buffer;
            del self.tool_cfg;
            del self.ext_cmd;
            del self.sn;
        # terminate thread
        if (None != self.product): 
            log='Thread exit ( %d )'%(self.err_code)
            print_log(log);
            self.product.Py_PyThreadExit(self.product_tid, self.err_code);
            if (True == self.debug):
                self.product.TerminateDbg(self.product_tid);
        log='Take Time: %s' %(str(datetime.datetime.now() - self.start))
        print_log(log);
          
    def EXCEPT(self, ret, show, error):
        self.err_code = ret;
        if (len(error) > 0):
            import traceback;
            exp =sys.exc_info();
            if (len(exp) > 2 and exp[2] != None):
                tb = traceback.extract_tb(exp[2])[0];
                fname = str(tb[0]).split(str(os.sep));
                error = error + '(\"%s\" in %s(%s, line %s))'%(tb[3], tb[2], fname[len(fname)-1], tb[1]);
                #print traceback.format_exc();
                
            if (None != self.product):
                # Write error info into log file
                self.product.Py_ShowMessage(0x01, self.product_tid, error, len(error));
                # Show error info on tool UI
                if (show == True):
                    self.product.Py_ShowMessage(0x02, self.product_tid, error, len(error));
                raise Exception(error);
        return ret;
    
    def InitProduction_NT(self, script_dll, product_dll):
        """
        called while product or upgrade firmware into device
        """
        self.product = cdll.LoadLibrary(product_dll);
         
        if (os.name == 'posix'):  
            dll = '';
            path = product_dll.split(str(os.sep));
            for i in range(len(path)-1):
                dll += path[i];
                dll += str(os.sep);
            self.product.Py_SetLibPath(dll);
          
        if (True == self.debug):
            self.InitDbg_NT();
        if (0 == self.product_tid):
            self.EXCEPT(-1, False, 'Device not found');
        self.fwscript = FirmwareScript();
        image = c_buffer('\0', 520);
        fwLen = self.product.Py_GetFirmwareBin(self.buffer, image);
        if (fwLen <= 0):
            self.EXCEPT(-2, False, 'Load firmware failed');
            
        if (True != self.fwscript.Open(self.buffer, image, script_dll)):
            self.EXCEPT(-3, False, 'Load firmware failed');

        return 0;

    def InitDbg_NT(self):
        if (True != os.path.isfile(self.dbg_fw)):
            return self.EXCEPT(-5, False, 'Firmware (%s) non-existent'%(self.dbg_fw));   

        self.product_tid = self.product.StartupDbg(self.dbg_fw);        
        if (0 == self.product_tid):
            return self.EXCEPT(-6, False, 'Failed to startup debugger, no device found');
        
        self.product.SetProductionCfg('PRODUCTION', '1');
        self.product.SetProductionCfg('FLASH_ERASE', '1');
        self.product.SetProductionCfg('PARTITION', '1');    
    def InitProduction(self, script_dll, product_dll,Para):
        """
        called while product or upgrade firmware into device
        """
        self.product = cdll.LoadLibrary(product_dll);	
    
        if (os.name == 'posix'):
            dll = '';
            path = product_dll.split(str(os.sep));
            for i in range(len(path)-1):
                dll += path[i];
                dll += str(os.sep);
            self.product.Py_SetLibPath(dll);
        if (True == self.debug):
            self.InitDbg(Para);
        if (0 == self.product_tid):
            self.EXCEPT(-1, False, 'Device not found');
        self.fwscript = FirmwareScript();
        image = c_buffer('\0', 520);
        fwLen = self.product.Py_GetFirmwareBin(self.buffer, image);
        if (fwLen <= 0):
            self.EXCEPT(-2, False, 'Load firmware failed');
        if (True != self.fwscript.Open(self.buffer, image, script_dll)):
            self.EXCEPT(-3, False, 'Load firmware failed');
        return 0;

    def InitDbg(self,Para):
        if (True != os.path.isfile(self.dbg_fw)):
            return self.EXCEPT(-5, False, 'Firmware (%s) non-existent'%(self.dbg_fw));  
        if (os.name == 'posix'):          
            if(Para.devmode == False):
                self.product.SetProductionCfg('DEVMODE','256');  
            elif(Para.devmode == True):
                self.product.SetProductionCfg('DEVMODE',Para.devmodepara);  
                return self.EXCEPT(0, True, 'It is sucessful to set device mode');
        self.product_tid = self.product.StartupDbg(self.dbg_fw);
        if (0 == self.product_tid):
            return self.EXCEPT(-6, False, 'Failed to startup debugger, no device found');
            
        self.product.SetProductionCfg('PRODUCTION', '1');

    def SetCmdBurnPara(self, para):
        if ( para.erase == True) :
            self.product.SetProductionCfg('FLASH_ERASE', '1');        
        
        if ( para.part != None) :
            self.product.SetProductionCfg('PARTITION', '1');
            self.product.SetProductionCfg('PARTITION', para.part); 
            #    print 'burn:' + para.part;
            log='burn:%s'%(para.part)
            print_log(log);
        elif ( para.all == True) :
            self.product.SetProductionCfg('PARTITION', '1');
        else:
            self.product.SetProductionCfg('PARTITION', '0');

    def DoADFU(self):

        # BOOT PARA
        self.product.Py_UpdateProgress(self.product_tid, 5); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD BOOT PARA ...');
        self.DownBootPara();
        # ADEC, F003
        self.product.Py_UpdateProgress(self.product_tid, 3); # 3%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD ADFUDEC ...');
        self.ADFUS('F003');   
        # switch ADEC, F003
        self.product.Py_UpdateProgress(self.product_tid, 7); # 7%
        self.product.Py_UpdateStatus(self.product_tid, 'SWITCH ADFUDEC ...');
        self.SWITCH('F003');
        # ADFUS, VMLX
        self.product.Py_UpdateProgress(self.product_tid, 15); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD VMLINUX ...');
        self.ADFUS('VMLX');
        # ADFUS, INRD
        self.product.Py_UpdateProgress(self.product_tid, 20); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD INITRD ...');
        self.ADFUS('INRD');
        # ADFUS, FDT
        self.product.Py_UpdateProgress(self.product_tid, 24); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD FDT ...');
        self.ADFUS('FDT');
        # ADFUS, ADFU
        self.product.Py_UpdateProgress(self.product_tid, 27); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD ADFUS ...');
        self.ADFUS('ADFU');
    
        # MBRINFO
        self.product.Py_UpdateProgress(self.product_tid, 32); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD MBR ...');
        self.DownMBR();
    
        self.product.Py_SetCommTimeout(self.product_tid, 120000);
        log='set time out to 2mins'
        print_log(log);
        
        # Partitions
        self.product.Py_UpdateProgress(self.product_tid, 35); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'DOWNLOAD PARTITIONS ...');
        self.DownPartitions(35, 95);
        # transfer over
        self.product.Py_SetCommTimeout(self.product_tid, 600000);
        log='set time out to 10mins'
        print_log(log)
        self.product.Py_UpdateProgress(self.product_tid, 95); # 5%
        self.product.Py_UpdateStatus(self.product_tid, 'TRANSFER OVER ...');
    
        return self.TransferOver();    

    def BootParaFileDown(self, MbrcName, dtbName, addr):
        log='DownAfiDtb:%s'%(MbrcName)
        print_log(log);
        fsize   = self.fwscript.FileSize(MbrcName);
        log='MBRCsize:%d' %(fsize)
        print_log(log);
        readed = self.fwscript.FileRead(MbrcName, 0, 512, self.buffer, myThreadLock);
        log='read size:%d' %(readed)
        print_log(log);
        if readed < 0x1800 :      
            return False;
        ph_offset = 0x1400;
        #img_size = c_uint32(0);
        img_offset = c_uint32(0);
        magic   = c_uint32(0); 
        numPart = c_uint32(0);
        memmove(addressof(magic), addressof(self.buffer)+ph_offset,  4);
        memmove(addressof(numPart), addressof(self.buffer)+ph_offset+60,  4);
        #  print 'magic: 0x%x, numpart=%d' %(magic.value, numPart.value);
        if (magic.value != 0x4b434150) or ( numPart.value > 10) or  ( numPart.value < 1):
            return False;
        for i in range(numPart.value) :
            str_buf ='';
            for k in range(16) :
                ch = self.buffer[ph_offset+64*i+64+k] & 0x7f;
                if ch == 0 :
                    break;
                str_buf = str_buf + str(chr(ch));
            log='name:%s'%(str_buf)
            print_log(log);
            #self.product.Py_ShowMessage(0x01, self.product_tid, log, len(log));
            if  str_buf != dtbName :
                continue;
            #memmove(addressof(img_size), addressof(self.buffer)+ph_offset+64*i+64+16,  4);
            memmove(addressof(img_offset), addressof(self.buffer)+ph_offset+64*i+64+20, 4);
            self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, 0x800, addr);
            img_offset.value = img_offset.value*512;
            memmove(addressof(self.buffer), addressof(self.buffer)+img_offset.value, 0x800);
            ret = self.product.Py_DownloadMem(self.product_tid, 1, addr, self.buffer, 0x800);
            log='FDT:addr=%x,img_offset=0x%x ret=%d'%(addr,img_offset.value,ret);
            print_log(log);
            #self.product.Py_ShowMessage(0x01, self.product_tid, log, len(log));
            if (0 != ret):
                return self.EXCEPT(-23, True, 'DOWNLOAD_MFDT_FAILED');
            return True;
        return False;
  
    def DownBootPara(self):
        log='DownBootPara'
        print_log(log);
        para = self.fwscript.ParamParam('BOOT_PARA', 'PARA', 2, (0,1));
        mbrcName = self.fwscript.ParamParam('PARTITION_I', 'MBRC', 1, (2,3));
        if (para == None ) or (mbrcName == None):
            return self.EXCEPT(-5, True, 'BOOT_PARA_NotExist');
        addr = c_uint32(int(para[1]));
        log='paraName:%s, addr:%x'%(para[0].encode('utf-8'),addr.value)
        print_log(log);
        if mbrcName[0][0] == '.' :
            NameP = mbrcName[0][2:];
        else :
            NameP = mbrcName[0];
        ret = self.BootParaFileDown(NameP, para[0],  addr.value);
        if ret == False :
            return self.EXCEPT(-5, True, 'BOOT_PARA_ERR');

    def ADFUS(self, sub_type):
        flag = c_uint32(0);
        memmove(addressof(flag), sub_type, 4);
        adfu  = self.fwscript.ParamParam('ADFUS', flag.value, 3, (0,1));
        fsize = self.fwscript.FileSize(adfu[0]);
        offset= 0;
        addr  = c_uint32(int(adfu[1]));
        if (sub_type == 'F003'):    #ADEC, less than 10M
            readed = self.fwscript.FileRead(adfu[0], offset, 512, self.buffer, myThreadLock);
            ret = self.product.Py_DownloadMem(self.product_tid, 1, addr.value, self.buffer, fsize);
            log='ADEC:%s, addr=%x,ret = %d'%(adfu[0].encode('utf-8'),addr.value,ret)
            print_log(log);
            if (0 != ret):
                return self.EXCEPT(-20, True, 'DOWNLOAD_ADEC_FAILED');
            return 0;    
        if (sub_type == 'ADFU'):  #ADFUS
            readed = self.fwscript.FileRead(adfu[0], offset, 512, self.buffer, myThreadLock);
            self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, readed, addr.value);
            ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, readed);
            log='ADFUS: %s, addr = %#x, ret = %d' %(adfu[0].encode('utf-8'), addr.value, ret)
            print_log(log);
            #self.product.Py_ShowMessage(0x01, self.product_tid, log, len(log));
            if (0 != ret):
                return self.EXCEPT(-23, True, 'DOWNLOAD_ADFUS_FAILED');
            addr = c_uint32(int(adfu[1])+0x40);
            self.ExtCmdParam(self.ext_cmd, 0x20, 0, 0, 0, 0, addr.value);
            ret = self.product.Py_Send(self.product_tid, self.ext_cmd, 0, 0);
            log='SWITCH: addr = %#x, ret = %d' %(addr.value, ret)
            print_log(log);
            if (0 != ret):
                return self.EXCEPT(-24, True, 'SWITCH_ADFUS_FAILED');
            log='after sleep'
            print_log(log);
            ret = self.product.Py_ReOpenDevice(self.product_tid, 1, 30000);
            log='ReOpenDevice: timeout = %d, ret = %d\n' %(180000, ret)
            print_log(log);
            if (0 != ret):
                return self.EXCEPT(-25, True, 'ADFUS_RESET_FAILED');
            return 0;
    
        if (sub_type == 'VMLX'): # VMLX
            log='ADFUS VMLX...'
            print_log(log);
            log='fsize: %d \n' %(fsize)
            print_log(log);
            size = fsize;
            while (size > 0):
                readed = self.fwscript.FileRead(adfu[0], offset, 512, self.buffer, myThreadLock);
                if (readed <= 0):
                    return self.EXCEPT(-26, 'DOWNLOAD_VMLX0_FAILED');
                self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, readed, addr.value);
                ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, readed);
                log='VMLX: %s, addr = %#x, ret = %d\n' %(adfu[0].encode('utf-8'), addr.value, ret)
                print_log(log);
                if (0 != ret):
                    return self.EXCEPT(-26, 'DOWNLOAD_VMLX0_FAILED');
                addr.value  = addr.value + readed;
                offset  = offset + readed;
                size    = size - readed;
            log='ADFUS VMLX...end'
            print_log(log);
            return 0;
    
        if (sub_type == 'INRD'): # INRD
            log='fsize: %d \n' %(fsize)
            print_log(log);
            size = fsize;
            while (size > 0):
                readed = self.fwscript.FileRead(adfu[0], offset, 512, self.buffer, myThreadLock);
                if (readed <= 0):
                    return self.EXCEPT(-26, 'DOWNLOAD_INRD_FAILED-0');
                self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, readed, addr.value);
                ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, readed);
                log='INRD: %s, addr = %#x, ret = %d\n' %(adfu[0].encode('utf-8'), addr.value, ret)
                print_log(log);
                if (0 != ret):
                    return self.EXCEPT(-26, 'DOWNLOAD_INRD_FAILED-1');
                addr.value  = addr.value + readed;
                offset  = offset + readed;
                size    = size - readed;
            log='ADFUS INRD...end'
            print_log(log);
            return 0;
    
        if (sub_type == 'FDT'):  #device tree
          log='ADFUS FDT...'
          print_log(log);
          readed = self.fwscript.FileRead(adfu[0], offset, 2048, self.buffer, myThreadLock);
          self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, readed, addr.value);
          ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, readed);
          log='FDT:%s, addr=%x, ret=%d' %(adfu[0].encode('utf-8'), addr.value, ret)
          print_log(log);
          if (0 != ret):
            return self.EXCEPT(-23, True, 'DOWNLOAD_FDT_FAILED');
          return 0;
    
        return self.EXCEPT(-39, False, 'Invalid ADFUS sub-type');
      
    def NOMUP(self,sub_type):
        adfu  = self.fwscript.ParamParam('NOMUP', sub_type, 1, (0,1));
        addr  = self.fwscript.ParamKey('NOM_ADDR', 0);
        size  = self.fwscript.FileSize(adfu[0]);
        readed= self.fwscript.FileRead(adfu[0], 0, 512, self.buffer, myThreadLock);
        self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, readed, addr);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, readed);
        log='NOMUP:%s, addr=%x, ret=%d' %(adfu[0].encode('utf-8'), addr, ret)
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-23, True, 'DOWNLOAD_ADFUS_FAILED');
        addr2 = addr+0x40;
        self.ExtCmdParam(self.ext_cmd, 0x20, 0, 0, 0, 0, addr2);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, 0, 0);
        log='SWITCH: addr=%x, ret=%d' %(addr2, ret)
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-24, True, 'SWITCH_ADFUS_FAILED');
        ret = self.product.Py_ReOpenDevice(self.product_tid, 1, 30000);
        log='ReOpenDevice: timeout=%d, ret=%d' %(30000,ret)
        print_log(log);
        if (0 != ret):
          return self.EXCEPT(-25, True, 'ADFUS_RESET_FAILED');
        return 0;
   
    def SWITCH(self, sub_type):
        flag = c_uint32(0);
        memmove(addressof(flag), sub_type, 4);
        adfu    = self.fwscript.ParamParam('ADFUS', flag.value, 3, (0,1));
        fsize   = self.fwscript.FileSize(adfu[0]);
        offset  = 0;
        addr    = c_uint32(int(adfu[1]));
     
        if (sub_type == 'F003'):    #ADEC, less than 10M
            ret = self.product.Py_SwitchFW(self.product_tid, addr.value);
            log='SWITCH: addr=%x,ret=%d' %(addr.value, ret)
            print_log(log);
            if (0 != ret):
                return self.EXCEPT(-21, True, 'SWITCH_ADEC_FAILED');
            return 0;

    def ExitAdfu(self):
        self.ExtCmdParam(self.ext_cmd, 0x23, 0, 0, 0, 0, 0);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, 0);
        if (0 != ret):
            return self.EXCEPT(-33, True, 'EXITADFU_FAILED');
        ret = self.product.Py_ReOpenDevice(self.product_tid, 1, 30000);
        log='ReOpenDevice:timeout=%d,ret=%d' %(30000, ret)
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-35, True, 'EXITADFU_RESET_FAILED');
        return 0;

    def DownFile(self, key):
        fcfg    = self.fwscript.ParamKey(key, 0);
        addr    = c_uint32(int(self.fwscript.ParamKey(key, 1)));
        fsize   = self.fwscript.FileSize(fcfg); # less than 10M
        read    = self.fwscript.FileRead(fcfg, 0, 512, self.buffer, myThreadLock);
    
        self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, read, addr.value);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, read);
        log='File %s: %s, %d, %d' %(key, fcfg.encode('utf-8'), read, ret);
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-50, True, 'SEND_'+key+'_FAILED');
        return 0;

    def DownMBR(self):
        fmbr    = self.fwscript.ParamKey('MBR_CONFIG', 0);
        addr    = c_uint32(int(self.fwscript.ParamKey('MBR_CONFIG', 1)));
        fsize   = self.fwscript.FileSize(fmbr); # less than 10M
        read    = self.fwscript.FileRead(fmbr, 0, 1024, self.buffer, myThreadLock);
    
        log='DownMBR:%s, addr=%x, size=%d, read=%d' %(fmbr.encode('utf-8'), addr.value, fsize, read);
        print_log(log);
        """
        分析分区表，提取分区表，转换成结构数组再下发给小机端。结构：
        struct mbr_info
        {
            int  size; // MB
            int  reserved;
            char name[24];
        };
        """
        str_buf = ' ';
        for i in range(read) :
            if (self.buffer[i]&0x7f) == 0 :
                continue;
            str_buf = str_buf + str(chr(self.buffer[i]&0x7f));
    
        partion_list=[];
        #parttion include mbr_info
        Build_Partion(str_buf, partion_list);
        num = 0;
        img_cfg_size = c_uint32(0);
        memset(addressof(self.buffer), 0x0, 1024*32);        
        for part in partion_list :
            img_cfg_size.value= int(part.size);
            memmove(addressof(self.buffer) + num*32, addressof(img_cfg_size), 4);
            for i in range(len(part.label)):
                self.buffer[num*32+8+i] = ord(part.label[i]);
                if ( i > 23 ) :
                    break;
            num = num + 1;
        read = num * 32;
        #是否删除flash分区.
        memset(addressof(self.tool_cfg), 0x0, sizeof(self.tool_cfg));
        self.product.Py_GetProductionConfig('FLASH_ERASE', 0, self.tool_cfg);
        cfg = c_uint32(0);
        cfg.value = int(self.tool_cfg.value[0]);
        if (cfg.value == 1 or cfg.value == 2):
            memmove(addressof(self.buffer)+4, addressof(cfg), 4);
            #  msg_log = "FLASH_ERASE";
            #  self.product.Py_ShowMessage(0x01, self.product_tid, msg_log, len(msg_log));
            log='FLASH_ERASE'
            print_log(log);
            log='reinit erase cfg.value %d'%cfg.value
            print_log(log);
        """
        分区表：mbr  misc  recover ......
        工具的partition.cfg 编号顺序是 mbrec.bin uboot.bin misc recovery ......
        mbr 是保留给gpt和启动代码空间(mbrec.bin uboot.bin)
        """
        self.partitions = num;
        img_new_size = c_uint32(0);  
        log='part-max = %d'%num
        print_log(log);
        for p in range( 1, num):
            memmove(addressof(img_cfg_size), addressof(self.buffer) + p*32, 4);
            memset(addressof(self.tool_cfg), 0x0, sizeof(self.tool_cfg));
            self.product.Py_GetProductionConfig('PARTITION', p+1, self.tool_cfg); 
            if (self.tool_cfg.value[0] == '1'):
                if partion_list[p].downloadfile == 'FMT':
                    log='Partition %d= FMT,label=%s' %(p+1,partion_list[p].label)
                    print_log(log);
                    img_new_size.value = self.product.Py_GetImageSize(self.product_tid, 8, p+1, 0, 0);
                    img_new_size.value = (img_new_size.value + 2047) // 2048;
                    log='Partition %d cfg = %d size = %d' %(p+1, img_cfg_size.value, img_new_size.value)
                    print_log(log);
                    continue;
                if (partion_list[p].size== '-1' and partion_list[p].downloadfile == 'DIR'):
                   self.udisk_dir = '1';
                   log= 'partition udisk downloadfile is DIR ,udisk_dir=%s'%(self.udisk_dir)
                   print_log(log)
                   continue;
                img_new_size.value = self.product.Py_GetImageSize(self.product_tid, 8, p+1, 0, 0);
                img_new_size.value = (img_new_size.value + 2047) // 2048;
                log='Partition %d cfg = %d size = %d' %(p+1, img_cfg_size.value, img_new_size.value)
                print_log(log);
                if ( ( int(partion_list[p].flag, 16) )& 0x01 == 0x01):
                    log='auto config image size'
                    print_log(log);
                    memmove(addressof(self.buffer) +p*32, addressof(img_new_size), 4);
                elif (img_new_size.value > img_cfg_size.value):
                    # over-flow
                    return self.EXCEPT(-60, True, 'PARTITION_OVERFLOW');
            else:
                log='Partition %d = 0' %(p+1)
                print_log(log);
    
    
        self.ExtCmdParam(self.ext_cmd, 0x13, 0, 0, 0, read, addr.value);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, self.buffer, read);
        log='MBR: %s, %d, %d' %(fmbr.encode('utf-8'), read, ret)
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-61, True, 'SEND_MBRINFO_FAILED');
        
        return 0;

    def DownPartitions(self, start_percent, end_percent):
        #copy to udisk
        udisk_cap = 0;
        udisk_cap_offset = 0;
        udisk_index = 0;
        #get udisk_index in all partitions
        udisk_index = self.fwscript.ParamKey('PARTITION_UDISK_INDEX', 0);
        self.ExtCmdParam(self.ext_cmd, 0x40 + 0x80, 0x20, udisk_index, 0, 0x200, 0);
        self.product.Py_SetCommTimeout(self.product_tid, 240000);
    
        ret = self.product.Py_Recv(self.product_tid, self.ext_cmd, self.buffer, 0x200);
        log='CHECK_PARTITION = %d'%ret
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-70, True, 'UPLOAD_PARTITION_FAILED');
        else :
            log='CHECK_PARTITION,ret=%d, num=%d' %(ret,self.buffer[0])
            print_log(log);
            if (self.buffer[0] != 0):
                log='overflow fail,ret=%d, num=%d' %(ret, self.buffer[0])
                print_log(log);
                return self.EXCEPT(-71, True, 'PARTITION_CAP_OVERFLOW');
          
            #get udisk_cap(Sectors)
            if (self.udisk_dir == '1'):            
                udisk_cap_offset = 0x10; #a~i,udisk is 'i'
                if(self.buffer[udisk_cap_offset + 3] < 0):
                    udisk_cap = 128 + (self.buffer[udisk_cap_offset + 3] & 0x7f)
                else:
                    udisk_cap = self.buffer[udisk_cap_offset + 3];
                udisk_cap = udisk_cap << 8;
                if(self.buffer[udisk_cap_offset + 2] < 0):
                    udisk_cap = udisk_cap + 128 + (self.buffer[udisk_cap_offset + 2] & 0x7f)
                else:
                    udisk_cap = udisk_cap + self.buffer[udisk_cap_offset + 2];
                udisk_cap = udisk_cap << 8;
                if(self.buffer[udisk_cap_offset + 1] < 0):
                    udisk_cap = udisk_cap + 128 + (self.buffer[udisk_cap_offset + 1] & 0x7f)
                else:
                    udisk_cap = udisk_cap + self.buffer[udisk_cap_offset + 1];
                udisk_cap = udisk_cap << 8;
                if(self.buffer[udisk_cap_offset] < 0):
                    udisk_cap = udisk_cap + 128 + (self.buffer[udisk_cap_offset] & 0x7f)
                else:
                    udisk_cap = udisk_cap + self.buffer[udisk_cap_offset]

                log='udisk_cap %d' %( udisk_cap);
                print_log(log);
        image_size = 0;
        total_size = 0;
        # calculate total size
        log='Calculate total size'
        print_log(log);
        for p in range (0, self.partitions+1):
            memset(addressof(self.tool_cfg), 0x0, sizeof(self.tool_cfg));
            self.product.Py_GetProductionConfig('PARTITION', p, self.tool_cfg);
            if (self.tool_cfg.value[0] == '1'):
                if(p !=udisk_index):
                    image_size = self.product.Py_GetImageSize(self.product_tid, 8, p, 0, 0)
                else:
                    image_size = self.product.Py_GetImageSize(self.product_tid, 8, p, 0,udisk_cap)
                    if(self.udisk_dir == '1'):
                        if(udisk_cap < image_size):
                            log='----Partition %d size=%d, total=%d' %(p,image_size,total_size)
                            print_log(log);
                            return self.EXCEPT(-75, True,'UDISK_DIR_TOO_LARGE');
                image_size = (image_size + 2047) & 0xfffff800;
                total_size = total_size + image_size;
                log='Partition %d size=%d, total=%d' %(p,image_size,total_size)
                print_log(log);
            else :
                log='Partition %d size = 0' %(p)
                print_log(log);
        if (total_size == 0):
            return 0;
    
        step = total_size // (end_percent - start_percent);
    
        # download each partition, include mbrec.bin uboot.bin
        for p in range (0, self.partitions+1):
            memset(addressof(self.tool_cfg), 0x0, sizeof(self.tool_cfg));
            self.product.Py_GetProductionConfig('PARTITION', p, self.tool_cfg);
            if (self.tool_cfg.value[0] == '1'):
                if(udisk_index != p):
                    image_size = self.product.Py_GetImageSize(self.product_tid, 8, p, 0, 0)
                else:
                    image_size = self.product.Py_GetImageSize(self.product_tid, 8, p, 0, udisk_cap)
                image_size = (image_size + 2047) & 0xfffff800;
                end_percent = start_percent + image_size // step;
                if(udisk_index != p):
                    ret = self.product.Py_DownloadImage(self.product_tid, 8, p, 0, image_size, 0, start_percent, end_percent);
                else:
                    ret = self.product.Py_DownloadImage(self.product_tid, 8, p, 0, udisk_cap , 0, start_percent, end_percent);
                log='Partition %d size = %d, %d%% - %d%%, ret = %d' %(p, image_size, start_percent, end_percent, ret)
                print_log(log);
                if (0 != ret):
                    msg_log = ('write p%d size = %d : fail' %(p, image_size) );
                    log='write p%d size = %d : fail' %(p, image_size)
                    print_log(log);
                    self.product.Py_ShowMessage(0x01, self.product_tid, msg_log, len(msg_log));
                    return self.EXCEPT(-80-p, True, ('write partition=%d err' % p) );
                start_percent = end_percent;
                msg_log = ('write p%s size = %d : ok' %(p, image_size) );
                log='write p%s size = %d : ok'%(p, image_size)
                print_log(log);
                self.product.Py_ShowMessage(0x01, self.product_tid, msg_log, len(msg_log));
                    
        return 0;


    def TransferOver(self):
        self.ExtCmdParam(self.ext_cmd, 0x30, 0, 0, 0, 0, 0);
        self.product.Py_SetCommTimeout(self.product_tid,1200000);
        ret = self.product.Py_Send(self.product_tid, self.ext_cmd, 0, 0);
        log='TransferOver(%d)'%ret
        print_log(log);
        if (0 != ret):
            return self.EXCEPT(-90, True, 'TRANSFER_OVER_FAILED');
    
        if (self.hdcp_burn):
            memset(addressof(self.tool_cfg), 0x0, 4);
            memmove(addressof(self.tool_cfg) + 4, addressof(self.sn), 16);
            self.product.Py_SetProductionConfig('HDCP_KEY', 0, self.tool_cfg);
                              
        return 0;
  
    def GetHDCPBurnStatus(self):
        memset(addressof(self.tool_cfg), 0x0, sizeof(self.tool_cfg));
        self.product.Py_GetProductionConfig('HDCP_KEY', 0, self.tool_cfg);
        hdcp_key_cfg = int(self.tool_cfg.value[0]);
        self.hdcp_burn = hdcp_key_cfg;
        log='HDCP key burn %d' %(self.hdcp_burn)
        print_log(log);
        return hdcp_key_cfg;
    def ExtCmdParam(self, ret, subcode, p0, p1, p2, length, addr):
        try:
            memset(addressof(ret), 0x0, 16);
            ret[0] = subcode;
            ret[1] = p0;
            ret[2] = p1;
            ret[3] = p2;
            nVal = c_uint32(length);
            memmove(addressof(ret)+4, addressof(nVal), 4);
            nVal.value = addr;
            memmove(addressof(ret)+8, addressof(nVal), 4);
        except Exception as e:
            self.EXCEPT(-91, False, str(e));
        return;
    def ShowPartitions(self,fw,Para):
        try:
            fmbr    = self.fwscript.ParamKey('MBR_CONFIG', 0);
            addr    = c_uint32(int(self.fwscript.ParamKey('MBR_CONFIG', 1)));
            fsize   = self.fwscript.FileSize(fmbr); # less than 10M
            read    = self.fwscript.FileRead(fmbr, 0, 1024, self.buffer, myThreadLock);
            str_buf = ' ';
            for i in range(read) :
                if (self.buffer[i]&0x7f) == 0 :
                    continue;
                str_buf = str_buf + str(chr(self.buffer[i]&0x7f));
            #print str_buf;
            partion_list=[];
            #parttion include mbr_info
            Build_Partion(str_buf, partion_list);
            if(Para.parse_partition_tag == True):
                Para.partition_cfg[0]=['p0','bootloader','1MB','\n'];
                Para.partition_cfg[1]=['p1','uboot','1MB','\n'];
                num = 2;
                for part in partion_list :
                    if part.label == 'MBR' :
                        continue;
                    pn = 'p'+str(num);
                    Para.partition_cfg[num]=[pn,part.label,part.size,'\n'];
                    num = num + 1;
            else:
                print 'p0: bootloader, size=1MB';
                print 'p1: uboot, size=1MB';
                num = 2;
                for part in partion_list :
                    if part.label == 'MBR' :
                        continue;
                    print 'p%d: %s, size=%sMB'%(num, part.label, part.size);
                    num = num + 1;
          
        except Exception as e:
            print '%s(%s)' %(type(e),e);
        return False;


#================================================================
if __name__ == '__main__':
    #dbg_fw = sys.argv[1];#'H:\\Firmware\\705A\\lollipop_atm7059a_demo_86v_150107_large.fw';
    #script = sys.argv[2];#'/home/iter/705a/firmware/lollipop_atm7059a_demo_86v_150107.fw';  
    #product= sys.argv[3];#'/home/iter/705a/bin/12.04/x64/libScript.so';
    if (os.name == 'posix'):
        script = '/home/iter/705a/bin/12.04/x64/libScript.so';
        product= '/home/iter/705a/bin/12.04/x64/libProduction.so';
        dbg_fw = '/home/iter/firmware/lollipop_atm7059a_demo_86v_150120_large_udisk.fw';    
    elif (os.name == 'nt'):
        #product= 'D:\\Code\\Production Tool - SVN5470 - PAD_BOX\\Bin\\Production.dll';
        product= 'C:\\Program Files\\Actions\\PAD量产工具\\1.09.02\\Production.dll';
        #script = 'D:\\Code\\Production Tool - SVN5470 - PAD_BOX\\Bin\\Script.dll';
        script= 'C:\\Program Files\\Actions\\PAD量产工具\\1.09.02\\Script.dll';
        #dbg_fw = 'H:\\Firmware\\705A\\lollipop_atm7059a_demo_86v_150120_large_udisk.fw'; 
        dbg_fw = 'x:\\S500\\Tag0811\\minilinux_sdk\\owl\\out\\s500_linux_gb5_wxga\\images\\s500_linux_gb5_wxga_150811.fw';
    #MakeBin(script, fw, 'AFI', 'f:\\afi.bin');
    Production(script, product, 0, 1, dbg_fw);




